osrm = require('osrm');
exports.getOSRM = (path,algorithm='MLD')=>{
    return new osrm({
        path: path,
        algorithm: algorithm,
    });
}

exports.osrmRoute = (osrmClient, coords) => {
    return new Promise((resolve, reject) => {
        osrmClient.route({
            coordinates: coords
        }, function(err, result) {
            if (err) {
                reject(err)
                return
            }
            resolve(result);
        });
    });
}

exports.osrmTable = (osrmClient, coords, mulit=1) =>{
    return new Promise((resolve, reject) => {
        osrmClient.table({
            coordinates: coords
        }, function(err, result) {
            if (err) {
                reject(err)
                return
            }
            let width = result.durations.length;
            let height = result.durations[0].length;
            for (let i = 0; i < width; i++) {
                for (let j = 0; j < height; j++) {
                    result.durations[i][j] = Math.floor(result.durations[i][j] * multi);
                }
            }
            resolve(result);
        });
    });
}

exports.shell = (cmd)  => {
    const exec = require('child_process').exec;
    return new Promise((resolve, reject) => {
        exec(cmd, (error, stdout, stderr) => {
            if (error) {
                console.warn(error);
                reject(error);
                return;
            }
            resolve(stdout ? stdout : stderr);
        });
    });
}
